module Types.Value
  ( Value(..)
  , Valuable(..)
  ) where

import Types.Values

import Data.Text (Text)
import Language.Haskell.TH.Syntax (Lift)

data Value = String String
           | Text Text
           | Bool Bool
           | ImageConversionSettings ImageConversionSettings
           | Template Template
           | Empty
           | Tuple (Value, Value)
           | List [Value]
  deriving (Show, Lift)

class Valuable a where
  toValue :: a -> Value
  fromValue :: Value -> a

instance Valuable String where
  toValue = String
  fromValue = \case
    String a -> a
    _ -> error "unexpected"

instance Valuable Text where
  toValue = Text
  fromValue = \case
    Text a -> a
    _ -> error "unexpected"

instance Valuable Bool where
  toValue = Bool
  fromValue = \case
    Bool a -> a
    _ -> error "unexpected"

instance Valuable ImageConversionSettings where
  toValue = ImageConversionSettings
  fromValue = \case
    ImageConversionSettings a -> a
    _ -> error "unexpected"
